%global gimpplugindir %(gimptool --gimpplugindir)/plug-ins

%global use_system_cimg 1

%global zart_version 20220629git34ebf6c
%global gmic_qt_version 20230622git5a9e8ad
%global gmic_community_version 20230626git33f15570

%global shortver 326

Summary: GREYC's Magic for Image Computing
Name:    gmic
Version: 3.2.6
Release:    1%{?dist}
Source0: https://gmic.eu/files/source/%{name}_%{version}.tar.gz
Source1: zart-%{zart_version}.tar.gz
Source2: gmic-qt-%{gmic_qt_version}.tar.gz
Source3: gmic-community-%{gmic_community_version}.tar.gz
License: ( CECILL-2.1 OR CECILL-C ) AND GPL-3.0-or-later
Url: http://gmic.eu/
%if %{use_system_cimg}
BuildRequires: CImg-devel == %{version}
%endif
BuildRequires: libX11-devel
BuildRequires: libXext-devel
BuildRequires: libtiff-devel
BuildRequires: libpng-devel
BuildRequires: libjpeg-devel
BuildRequires: fftw-devel
BuildRequires: openexr-devel
BuildRequires: imath-devel
BuildRequires: zlib-devel
BuildRequires: gimp-devel-tools
BuildRequires: hdf5-devel
BuildRequires: opencv-devel
BuildRequires: GraphicsMagick-c++-devel
BuildRequires: qt5-qtbase-devel
BuildRequires: libcurl-devel
BuildRequires: gcc-c++
BuildRequires: desktop-file-utils
BuildRequires: make
BuildRequires: chrpath

Requires: %{name}-libs = %{version}-%{release}




%description
G'MIC is an open and full-featured framework for image processing, providing
several different user interfaces to convert/manipulate/filter/visualize
generic image datasets, from 1d scalar signals to 3d+t sequences of
multi-spectral volumetric images.

%package devel
Requires: %{name}-libs = %{version}-%{release}
Summary: Development files for G'MIC

%package gimp
Requires: %{name} = %{version}-%{release}
Summary: G'MIC plugin for GIMP

%package libs
Summary: G'MIC shared libraries

%description devel
G'MIC is an open and full-featured framework for image processing, providing
several different user interfaces to convert/manipulate/filter/visualize
generic image datasets, from 1d scalar signals to 3d+t sequences of
multi-spectral volumetric images.

Provides files for building applications against the G'MIC API

%description gimp
G'MIC is an open and full-featured framework for image processing, providing
several different user interfaces to convert/manipulate/filter/visualize
generic image datasets, from 1d scalar signals to 3d+t sequences of
multi-spectral volumetric images.

Provides a plugin for using G'MIC from GIMP

%description libs
G'MIC is an open and full-featured framework for image processing, providing
several different user interfaces to convert/manipulate/filter/visualize
generic image datasets, from 1d scalar signals to 3d+t sequences of
multi-spectral volumetric images.

Provides G'MIC shared libraries

%prep
%setup -q -a 1 -a 3




rm -f zart/.qmake.stash

%build
cd src

ln -fs ../gmic-community/libcgmic/gmic_libc.cpp .
ln -fs ../gmic-community/libcgmic/gmic_libc.h .
ln -fs ../gmic-community/libcgmic/use_libcgmic.c .

%if %{use_system_cimg}
mv CImg.h CImg.h.bak
cp /usr/include/CImg.h CImg.h
%endif

make OPT_CFLAGS="%{optflags} -g" NOSTRIP=1 PREFIX=%{_prefix} LIB=%{_lib} cli lib libc

cd ../gmic-qt
%{qmake_qt5} CONFIG+=release GMIC_PATH=../src HOST=gimp gmic_qt.pro && %{make_build}
%{qmake_qt5} CONFIG+=release GMIC_PATH=../src HOST=none gmic_qt.pro && %{make_build}

cd ../zart
%{qmake_qt5} CONFIG+=release GMIC_PATH=../src zart.pro && %{make_build}

%install
mv gmic-qt/COPYING COPYING-gmic-qt
mv gmic-community/libcgmic/COPYING COPYING-libcgmic


iconv -f iso8859-1 -t utf-8 COPYING > COPYING.conv && mv -f COPYING.conv COPYING
iconv -f iso8859-1 -t utf-8 COPYING-libcgmic > COPYING-libcgmic.conv && mv -f COPYING-libcgmic.conv COPYING-libcgmic

cd src
make DESTDIR=%{buildroot} PREFIX=%{_prefix} LIB=%{_lib} install

desktop-file-validate %{buildroot}/%{_datadir}/applications/gmic_qt.desktop
desktop-file-validate %{buildroot}/%{_datadir}/applications/zart.desktop

mkdir -p %{buildroot}%{_sysconfdir}/bash_completion.d
mv %{buildroot}/%{_datadir}/bash-completion/completions/gmic %{buildroot}/%{_sysconfdir}/bash_completion.d/gmic
rm -rf %{buildroot}/%{_datadir}/bash-completion/completions/

chmod -x %{buildroot}/%{_sysconfdir}/bash_completion.d/gmic

chrpath --delete %{buildroot}%{_bindir}/gmic
chrpath --delete %{buildroot}%{_libdir}/libcgmic.so.%{shortver}
chrpath --delete %{buildroot}%{_libdir}/libgmic.so.%{shortver}

%post -p /sbin/ldconfig libs
%postun -p /sbin/ldconfig libs

%post
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

%files
%doc README
%license COPYING COPYING-gmic-qt COPYING-libcgmic
%{_bindir}/gmic
%{_bindir}/gmic_qt
%{_bindir}/zart
%{_sysconfdir}/bash_completion.d/gmic
%{_mandir}/man1/%{name}.1.gz
%{_mandir}/fr/man1/%{name}.1.gz
%{_datadir}/applications/gmic_qt.desktop
%{_datadir}/applications/zart.desktop
%{_datadir}/icons/hicolor/48x48/apps/gmic_qt.png
%{_datadir}/icons/hicolor/48x48/apps/zart.png
%{_datadir}/icons/hicolor/scalable/apps/gmic_qt.svg
%{_datadir}/icons/hicolor/scalable/apps/zart.svg

%files devel
%{_prefix}/include/gmic.h
%{_prefix}/include/gmic_libc.h
%{_libdir}/libgmic.so
%{_libdir}/libcgmic.so

%files gimp
%{gimpplugindir}/gmic_gimp_qt
%{gimpplugindir}/gmic_cluts.gmz
%{gimpplugindir}/gmic_denoise_cnn.gmz

%files libs
%license COPYING COPYING-libcgmic
%{_libdir}/libgmic.so.3*
%{_libdir}/libcgmic.so.3*

%changelog
* Wed Jul 24 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.2.6-1
- initial build
